echo ""
echo -n "server: "
echo -n $net_default_server
echo -n " client: "
net_ls_addr
echo ""
echo "--------------------------------------------------------------------------"
echo "Automated Installation Management System (AIMS). server: @AIMS_SERVER@"
echo "                      Boot from disk in 5 seconds."
echo "Press [ENTER] for network boot. Press [TAB] for text mode network boot."
echo "--------------------------------------------------------------------------"

# this is modified sleep returning:
# 0 - timeout
# 1 - ESC
# 2 - TAB
# 3 - ENTER
sleep -i 5

set retcode=$?

clear

if [ $retcode == 1 ]; then
    exit
fi

if [ $retcode == 0 ]; then
    exit
fi

if [ $retcode == 3 ]; then
    terminal_output gfxterm
    set gfxmode="800x600;640x480;auto"
    set theme=theme.txt
fi


set color_normal=white/black
set color_highlight=black/white
set menu_color_normal=white/black
set menu_color_highlight=black/white
set timeout=15
set default='Exit to EFI Shell'
set fallback='Exit to EFI Shell'
set pager=1

menuentry 'Install CentOS Stream 8 Linux x86_64 (CS8)' {
    clear
    echo -n 'loading kernel ...'
    linux (http)/aims/boot/CS8_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/s8/BaseOS/x86_64/os/ inst.addrepo=CERN,http://linuxsoft.cern.ch/cern/centos/s8/CERN/x86_64/ inst.addrepo=locmap,http://linuxsoft.cern.ch/internal/repos/potd8s-stable/x86_64/os/ ks=http://linuxsoft.cern.ch/kickstart/centos8_default.ks
    clear
    echo -n 'loading initrd ...'
    initrd (http)/aims/boot/CS8_X86_64/initrd
}

menuentry 'Install CentOS 8 Linux x86_64 (C8)' {
    insmod progress
    clear
    echo -n 'loading kernel ...'
    linuxefi (http)/aims/boot/C8_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/8/BaseOS/x86_64/os/ inst.addrepo=CERN,http://linuxsoft.cern.ch/cern/centos/8/CERN/x86_64/ inst.addrepo=locmap,http://linuxsoft.cern.ch/internal/repos/potd8-stable/x86_64/os/ ks=http://linuxsoft.cern.ch/kickstart/centos8_default.ks
    clear
    echo -n 'loading initrd ...'
    initrdefi (http)/aims/boot/C8_X86_64/initrd
}

menuentry 'Install CERN CentOS 7 Linux x86_64 (CC7)' {
    insmod progress
    clear
    echo -n 'loading kernel ...'
    linuxefi (http)/aims/boot/CC7_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7/os/x86_64/
    clear
    echo -n 'loading initrd ...'
    initrdefi (http)/aims/boot/CC7_X86_64/initrd
}

menuentry 'Install RHEL 8.4 x86_64 (license required)' {
    insmod progress
    clear
    echo -n 'loading kernel ...'
    linuxefi (http)/aims/boot/RHEL_8_4_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/8/8.4/x86_64/
    clear
    echo -n 'loading initrd ...'
    initrdefi (http)/aims/boot/RHEL_8_4_X86_64/initrd
}

menuentry 'Install RHEL 7.9 x86_64 (license required)' {
    insmod progress
    clear
    echo -n 'loading kernel ...'
    linuxefi (http)/aims/boot/RHEL_7_9_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/enterprise/rhel/server/7/7.9/x86_64/
    clear
    echo -n 'loading initrd ...'
    initrdefi (http)/aims/boot/RHEL_7_9_X86_64/initrd
}

menuentry 'Install RHEL 6.10 x86_64 (license required)' {
    insmod progress
    clear
    echo -n 'loading kernel ...'
    linux (http)/aims/boot/RHEL_6_10_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/6/6.10/x86_64/
    clear
    echo -n 'loading initrd ...'
    initrd (http)/aims/boot/RHEL_6_10_X86_64/initrd
}

submenu 'Rescue / Tools Menu' {
    if [ $retcode == 3 ]; then
        terminal_output gfxterm
        set gfxmode="800x600;640x480;auto"
        set theme=theme.txt
    fi

    menuentry 'Rescue Boot CentOS 8 Linux x86_64 (C8)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/C8_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/8/BaseOS/x86_64/os/ inst.addrepo=CERN,http://linuxsoft.cern.ch/cern/centos/8/CERN/x86_64/ inst.addrepo=locmap,http://linuxsoft.cern.ch/internal/repos/potd8-stable/x86_64/os/ rescue
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/C8_X86_64/initrd
    }

    menuentry 'Rescue Boot CERN CentOS 7 Linux x86_64 (CC7)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/CC7_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7/os/x86_64/ rescue
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/CC7_X86_64/initrd
    }

} # submenu 'Rescue / Tools Menu'

submenu 'Install Other Linux version' {

    if [ $retcode == 3 ]; then
        terminal_output gfxterm
        set gfxmode="800x600;640x480;auto"
        set theme=theme.txt
    fi

    menuentry 'Install CentOS Stream 8 Linux x86_64 for 20201Q2 (CS8_2021Q2)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linux (http)/aims/boot/CS82021.2_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/s8.2021.2/BaseOS/x86_64/os/ inst.addrepo=CERN,http://linuxsoft.cern.ch/cern/centos/s8.2021.2/CERN/x86_64/ inst.addrepo=locmap,http://linuxsoft.cern.ch/internal/repos/potd8s-stable/x86_64/os/ ks=http://linuxsoft.cern.ch/kickstart/centos8_default.ks
        clear
        echo -n 'loading initrd ...'
        initrd (http)/aims/boot/CS82021.2_X86_64/initrd
    }

    menuentry 'Install CentOS 8.2 Linux x86_64 (C8)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/C82_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/8.2/BaseOS/x86_64/kickstart/ inst.addrepo=CERN,http://linuxsoft.cern.ch/cern/centos/8.2/CERN/x86_64/ inst.addrepo=locmap,http://linuxsoft.cern.ch/internal/repos/potd8-stable/x86_64/os/ ks=http://linux.web.cern.ch/linux/centos8/default.ks
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/C82_X86_64/initrd
    }

    menuentry 'Install CentOS 8.1 Linux x86_64 (C8)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/C81_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/8.1/BaseOS/x86_64/kickstart/ inst.addrepo=CERN,http://linuxsoft.cern.ch/cern/centos/8.1/CERN/x86_64/ inst.addrepo=locmap,http://linuxsoft.cern.ch/internal/repos/potd8-stable/x86_64/os/ ks=http://linux.web.cern.ch/linux/centos8/default.ks
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/C81_X86_64/initrd
    }

    menuentry 'Install CERN CentOS 7.8 Linux x86_64 (CC7.8)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/CC78_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7.8/os/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/CC78_X86_64/initrd
    }

    menuentry 'Install RHEL 7.8 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_7_8_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/enterprise/rhel/server/7/7.8/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_7_8_X86_64/initrd
    }

    menuentry 'Install CERN CentOS 7.7 Linux x86_64 (CC7.7)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linux (http)/aims/boot/CC77_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7.7/os/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrd (http)/aims/boot/CC77_X86_64/initrd
    }

    menuentry 'Install CERN CentOS 7.6 Linux x86_64 (CC7.6)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/CC76_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7.6/os/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/CC76_X86_64/initrd
    }

    menuentry 'Install SL CERN 6 x86_64 (SLC6) (Unsupported)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        # RHEL6/SLC6 kernels cannot be booted with linuxefi (no EFI stub in kernel)
        linux (http)/aims/boot/SLC6X_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/cern/slc6X/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrd (http)/aims/boot/SLC6X_X86_64/initrd
    }

    menuentry 'Install RHEL 8.3 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_8_3_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/8/8.3/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_8_3_X86_64/initrd
    }

    menuentry 'Install RHEL 8.2 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_8_2_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/8/8.2/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_8_2_X86_64/initrd
    }

    menuentry 'Install RHEL 8.1 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_8_1_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/8/8.1/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_8_1_X86_64/initrd
    }

    menuentry 'Install RHEL 8.0 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_8_0_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/8/8.0/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_8_0_X86_64/initrd
    }

    menuentry 'Install RHEL 7.7 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_7_7_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/enterprise/rhel/server/7/7.7/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_7_7_X86_64/initrd
    }

    menuentry 'Install RHEL 7.6 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_7_6_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/enterprise/rhel/server/7/7.6/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_7_6_X86_64/initrd
    }

    menuentry 'Install RHEL 7.5 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_7_5_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/enterprise/rhel/server/7/7.5/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_7_5_X86_64/initrd
    }

    menuentry 'Install RHEL 7.4 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linuxefi (http)/aims/boot/RHEL_7_4_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/enterprise/rhel/server/7/7.4/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrdefi (http)/aims/boot/RHEL_7_4_X86_64/initrd
    }

    menuentry 'Install RHEL 6.9 x86_64 (license required)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linux (http)/aims/boot/RHEL_6_9_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/enterprise/rhel/server/6/6.9/x86_64/
        clear
        echo -n 'loading initrd ...'
        initrd (http)/aims/boot/RHEL_6_9_X86_64/initrd
    }

    menuentry 'Install FEDORA 32 x86_64 (unsupported)' {
        insmod progress
        clear
        echo -n 'loading kernel ...'
        linux (http)/aims/boot/FEDORA32_X86_64/vmlinuz ip=dhcp repo=http://linuxsoft.cern.ch/fedora/linux/releases/32/Server/x86_64/os/
        clear
        echo -n 'loading initrd ...'
        initrd (http)/aims/boot/FEDORA32_X86_64/initrd
    }
    # We cannot chainload with an url on grub, so we need to store the chainloader locally to use it
    # This entry will chainload to http://netboot.xyz. Note: Watch out, in the past security blocked the entire .xyz TLD
    menuentry 'Other Operating Systems (Unsupported, External)' {
        insmod chain
        chainloader /aims/loader/netbootxyz/netboot.xyz-snp.efi
    }

    submenu 'BE/CO System Installation Menu' {

        menuentry 'Install CentOS Stream 8 Linux x86_64 for 20201Q2 (CS8_2021Q2) [ethX]' {
            insmod progress
            clear
            echo -n 'loading kernel ...'
            linux (http)/aims/boot/CS82021.2_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/s8.2021.2/BaseOS/x86_64/os/ nofb biosdevname=0 net.ifnames=0 ks=nfs:cs-ccr-accadm:/opt/accadm/kickstart/
            clear
            echo -n 'loading initrd ...'
            initrd (http)/aims/boot/CS82021.2_X86_64/initrd
        }


        menuentry 'Install CERN CentOS 8.2 Linux x86_64 (C82) [ethX]' {
            insmod progress
            clear
            echo -n 'loading kernel ...'
            linuxefi (http)/aims/boot/C82_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/8.2/BaseOS/x86_64/kickstart/ nofb biosdevname=0 net.ifnames=0 ks=nfs:cs-ccr-accadm:/opt/accadm/kickstart/
            clear
            echo -n 'loading initrd ...'
            initrdefi (http)/aims/boot/C82_X86_64/initrd
        }
        menuentry 'Install CERN CentOS 7.9 Linux x86_64 (CC79) [ethX]' {
            insmod progress
            clear
            echo -n 'loading kernel ...'
            linuxefi (http)/aims/boot/CC79_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7.9/os/x86_64/ nofb biosdevname=0 net.ifnames=0 ks=nfs:cs-ccr-accadm:/opt/accadm/kickstart/
            clear
            echo -n 'loading initrd ...'
            initrdefi (http)/aims/boot/CC79_X86_64/initrd
        }
        menuentry 'Install CERN CentOS 7.8 Linux x86_64 (CC78) [ethX]' {
            insmod progress
            clear
            echo -n 'loading kernel ...'
            linuxefi (http)/aims/boot/CC78_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7.8/os/x86_64/ nofb biosdevname=0 net.ifnames=0 ks=nfs:cs-ccr-accadm:/opt/accadm/kickstart/
            clear
            echo -n 'loading initrd ...'
            initrdefi (http)/aims/boot/CC78_X86_64/initrd
        }
        menuentry 'Install CERN CentOS 7.7 Linux x86_64 (CC77) [ethX]' {
            insmod progress
            clear
            echo -n 'loading kernel ...'
            linuxefi (http)/aims/boot/CC77_X86_64/vmlinuz ip=dhcp inst.repo=http://linuxsoft.cern.ch/cern/centos/7.7/os/x86_64/ nofb biosdevname=0 net.ifnames=0 ks=nfs:cs-ccr-accadm:/opt/accadm/kickstart/
            clear
            echo -n 'loading initrd ...'
            initrdefi (http)/aims/boot/CC77_X86_64/initrd
        }
    } # submenu 'BE/CO System Installation Menu'
} # submenu 'Install Other Linux version'



menuentry 'Exit to EFI Shell' {
 clear
 exit
}

